extern struct BACKUP BAKundo;
extern char   BOXSTR[1024];             //  boxauto() string

void NextFile(void)
{
   struct BACKUP *BAKtmp;

   BAKtmp=ACTIVE;
   if(BAKtmp==BAKtmp->next) return;  else  BAKtmp=BAKtmp->next;
   ChangeFile(BAKtmp);
}

void ChangeFile(struct BACKUP *BAKnew)
{
   ChangeEditStatus(BAKnew);
   if(CTRL.INIT)                        // D Ctrl-Enter  Relation Open
   {
      Redraw(LINE.COMMAND,1);
      CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
      DisplayFname(FNAME);
      ChangeMessage();
   }
}

int Quit()
{
   #ifndef CSF
      return(Quit1());
   #else
      int ch;

      if(CTRL.MODIFY && CSF_TEST!=0)
      {
         LocateXY(1,LINE.MESSAGE);
         DisplayMessage("T : ɮפwקL, Tw} ? ( )",ON);
         LocateXY(36,LINE.MESSAGE);
         ch=Getch();
         DisplayMessage(" ",OFF);
         if(ch!='Y' && ch!='y') return(-1);
      }
      Save(FNAME);
      return(Quit1());
   #endif
}

int Quit1()
{
   struct BACKUP *BAKtmp1;
   struct BACKUP *BAKtmp2;
   struct LINK   *tmp,*buf;
   int    ch,i;
   int    append;

   #ifndef CSF
      if(CTRL.MODIFY && FNAME[0]!='.' && !CTRL.MACRO)      // Dɮ, BD
      {
         LocateXY(1,LINE.MESSAGE);
         DisplayMessage("T : ɮפwקL, Tw} ? (Y)",ON);
         LocateXY(36,LINE.MESSAGE);
         ch=Getch();
         DisplayMessage(" ",OFF);
         if(ch!='Y' && ch!='y' && ch!=0x0d) return(-1);
      }
   #endif

   AutoSaveUnlink(FNAME);                               // AutoSave File R

   append=UNDO.append;
   UNDO.append=OFF;

   tmp=head;
   while(tmp!=NULL)                      // ¦ FREE
   {
      buf=tmp->next;
      FreeMem(tmp);
      tmp=buf;
   }

   if(CTRL.MARK)
   {
      if(CTRL.MARKFILE==ACTIVE) UnMark();
   }

   if(ACTIVE==ACTIVE->next)
   {
      if(ACTIVE!=&BAKundo) FreeBAK(ACTIVE); else { UndoInit(); UNDO.append=OFF; }
      ACTIVE   =NULL;
      CTRL.EXIT=ON;
      return(1);
   }
   else
   {
      BAKtmp1=ACTIVE->prev;
      BAKtmp2=ACTIVE->next;
      BAKtmp1->next=BAKtmp2;
      BAKtmp2->prev=BAKtmp1;
      if(ACTIVE!=&BAKundo) FreeBAK(ACTIVE);
      ACTIVE=BAKtmp1;
   }

   // ------------ pG UNDO FILE ------------
   if(strcmp(FNAME,".UNDO")==0) { UndoInit(); UNDO.append=OFF; }

   // ------ ƥAثesɪA ------
   POS.MAXY    =(*ACTIVE).POS.MAXY    ;
   POS.NOWY    =(*ACTIVE).POS.NOWY    ;
   POS.NOWX    =(*ACTIVE).POS.NOWX    ;
   POS.SCRY    =(*ACTIVE).POS.SCRY    ;
   POS.SCRX    =(*ACTIVE).POS.SCRX    ;
   POS.MARX    =(*ACTIVE).POS.MARX    ;
   POS.OLDY    =(*ACTIVE).POS.OLDY    ;
   POS.CMD_NOWX=(*ACTIVE).POS.CMD_NOWX;
   POS.CMD_SCRX=(*ACTIVE).POS.CMD_SCRX;
   POS.CMD_MARX=(*ACTIVE).POS.CMD_MARX;
   POS.CURY    =(*ACTIVE).POS.CURY    ;
   POS.CURX    =(*ACTIVE).POS.CURX    ;

   CTRL.MODIFY =(*ACTIVE).CTRL.MODIFY ;
   CTRL.COMMAND=(*ACTIVE).CTRL.COMMAND;
   CTRL.EXIT   =(*ACTIVE).CTRL.EXIT   ;

   head=(*ACTIVE).HEAD;
   now =(*ACTIVE).NOW ;
   tail=(*ACTIVE).TAIL;

   PointerData(now);
   strcpy(text    ,U_STR);
   strcpy(old_text,U_STR);
   strcpy(cmd_text,(*ACTIVE).CMD_TEXT);
   strcpy(FNAME   ,(*ACTIVE).FNAME   );

   Redraw(LINE.COMMAND,1);
   CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
   DisplayFname(FNAME);

   UNDO.append=append;
   ChangeMessage();

   return(1);
}

int QuitAll()
{
   #ifndef CSF
      int           SW=OFF;
      struct BACKUP *BAKtmp;

      // ------------------ TwO_ɮ׳QקF -------------------
      if((*ACTIVE).CTRL.MODIFY || CTRL.MODIFY) SW=ON;
      BAKtmp=ACTIVE->next;
      while(BAKtmp!=ACTIVE && SW==OFF)
      {
         if((*BAKtmp).CTRL.MODIFY==ON) { SW=ON; break; }
         BAKtmp=BAKtmp->next;
      }

      if(SW && !CTRL.MACRO)
      {
         LocateXY(1,LINE.MESSAGE);
         DisplayMessage("T : ɮפwQקL, Tw} ? (N)",ON);
         LocateXY(46,LINE.MESSAGE);
         SW=Getch();
         DisplayMessage(" ",OFF);
         if(SW!='Y' && SW!='y') return(1);
      }

      // --------------- NҦɮ CTRL.MODIFY = OFF ----------------
      CTRL.MODIFY          =OFF;
      (*ACTIVE).CTRL.MODIFY=OFF;
      BAKtmp=ACTIVE->next;
      while(BAKtmp!=ACTIVE)
      {
         (*BAKtmp).CTRL.MODIFY=OFF;
         BAKtmp=BAKtmp->next;
      }

      while(ACTIVE!=NULL) Quit();
      DISPLAY.REDISPLAY=OFF;
      return(1);
   #else
      return(1);
   #endif
}

int Edit(char *fname)
{
   struct ffblk file;
   char         *ts,*dta;
   char         str[81];
   char         path[81];
   int          sw,init;
   int          load_cnt  =0;
   int          unload_cnt=0;


   // --------- P_O_hɶ} (ɦW '*'  '?') ------------
   ts=fname;
   while(*ts!='\0') { if(*ts=='*' || *ts=='?') break; else ts++; }

   if(*ts=='\0')    { sw=Edit1(fname); return(sw); }

   init=CTRL.INIT;
   GetPath(path,fname);
   dta=getdta();
   if(findfirst(fname,&file,0x20)==0)
   {
      if(ACTIVE!=NULL) CTRL.INIT=OFF;           // s}, @sܿù InitAll()
      sw=file.ff_attrib;
      if(sw==0x20 || sw==0x01 || sw==0x00)      // `ΰŪ
      {
         if(strlen(path)>3 || *path=='\0' || path[strlen(path)-1]=='\\')
            sprintf(str,"%s%s",path,file.ff_name);
         else
            sprintf(str,"%s\\%s",path,file.ff_name);

         if((sw=Edit1(str))==-2) { CTRL.INIT=init; setdta(dta); return(sw); }
         if(sw==0) load_cnt++; else unload_cnt++;
      }

      while(findnext(&file)==0)
      {
         if(ACTIVE!=NULL) CTRL.INIT=OFF;        // s}, @sܿù InitAll()
         sw=file.ff_attrib;
         if(sw==0x20 || sw==0x01 || sw==0x00)   // `ΰŪ
         {
            if(strlen(path)>3 || *path=='\0' || path[strlen(path)-1]=='\\')
               sprintf(str,"%s%s",path,file.ff_name);
            else
               sprintf(str,"%s\\%s",path,file.ff_name);

            if((sw=Edit1(str))==-2) { CTRL.INIT=init; setdta(dta); return(sw); }
            if(sw==0) load_cnt++; else unload_cnt++;
         }
      }
   }
   setdta(dta);
   CTRL.INIT=init;

   if(load_cnt==0 && unload_cnt==0)
   {
      sprintf(str,"T : Lɮ׳Q} !!");
   }
   else
   {
      if(unload_cnt!=0)
         sprintf(str,"T : %d ɮ׳QJ, %d ɮ׵LkJ(ؿBDrɩΰO^)",load_cnt, unload_cnt);
      else
         sprintf(str,"T : %d ɮ׳QJ",load_cnt);
   }
   DisplayMessageNoBeep(str);
   return(0);
}

// -----------------------------------------------------------------------
// 0 : `}     -1 : DrɩΰO^Ŷ    -2 : WL MAXOPEN
// -----------------------------------------------------------------------
int Edit1(char *fname)
{
   int           len,sw;
   int           fhandle;
   //char          str[513];
   char          name[81];
   int           ERROR=OFF;
   struct BACKUP *BAKtmp;
   struct BACKUP *BAKact;

   if(ACTIVE!=NULL)  ChangeEditStatus(ACTIVE);

   // -------- o㪺ɮצW --------
   if(GetFullFname(name,fname)==-1)
   {
      DisplayMessage("~ : }ɮ׿~",ON);
      return(-1);
   }

   if(ACTIVE!=NULL) BAKtmp=ACTIVE->next;  else  BAKtmp=NULL;

   if(BAKtmp!=NULL) sw=1; else sw=0;
   while(BAKtmp!=NULL)
   {
      if(stricmp(name,(*BAKtmp).FNAME)==0)
      {
         if(BAKtmp==ACTIVE)                             // ROƲM
         {
            ClearCommandLine();
            return(0);
         }

         ChangeEditStatus(BAKtmp);
         Redraw(LINE.COMMAND,1);                        // sܩROC
         CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
         DisplayFname(FNAME);
         return(0);
      }
      if(BAKtmp==ACTIVE) break; else  { BAKtmp=BAKtmp->next; sw++; }
   }

   if(sw==MAXOPEN && FREE)
   {
      sprintf(BOXSTR,"~ : KO̦huPɶ} %d ɮ",MAXOPEN);
      DisplayMessage(BOXSTR,ON);
      return(-2);
   }

   // ----------------- P_ɮ׬O_r -------------------
   sw=ChkIsText(name);
   if(sw==0)                                    // ɮפr
   {
      DisplayMessage("~ : ɮפr",ON);
      return(-1);
   }
   if((BAKtmp=MallocBAK())==NULL) return(-1);

   if(sw==-1)                                   // s}ɮ
   {
      strcpy(FNAME,name);
      InitAll();                                // ls STATUS
      ACTIVE=BAKtmp;
      ChangeEditStatus(BAKtmp);
      DisplayMessageNoBeep("T : s}ɮ");
   }
   else
   {
      // --------------------- }lJɮ --------------------
      strcpy(FNAME,name);
      InitAll();                                // ls STATUS
      ACTIVE=BAKtmp;
      ChangeEditStatus(BAKtmp);
      DisplayMessageNoBeep("T : ɮ׶}Ҥ,еy.... ");

      fhandle=open(name,O_RDONLY | O_TEXT);
      len=Fgets(fhandle,BOXSTR,1);   BOXSTR[255]='\0';
      if(len>0)
      {
         len--;
         if(BOXSTR[0]!='\0') { DP=DATAPointerData(now);  CompressSpace(STR,BOXSTR);  strcpy(DP,STR); }
      }

      while(Fgets(fhandle,BOXSTR,0)!=-1)
      {
         CompressSpace(STR,BOXSTR);
         if((new=AllocMemString(STR))!=NULL)       // Otm\
         {
            DP=DATAPointerData(new);
            strcpy(DP,STR);
         }
         else
         {
            ERROR=ON;
            break;
         }
         new->next=NULL;
         new->prev=now;
         now->next=new;
         tail     =new;
         now      =new;
         POS.MAXY++;
         if(FREE && POS.MAXY>MAXLINE)
         {
            DisplayMessage("~ : WLKOүJ̤j!! (Press a key)",ON);
            LocateXY(52,LINE.MESSAGE);
            Getch();
            DisplayMessage(" ",OFF);
            ERROR=ON;
            break;
         }
      }
      close(fhandle);

      // ------------------ YJ\ -----------------------
      if(!ERROR)
      {
         now=head;
         NowdataToText(now);
         DisplayMessage(" ",OFF);
         CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
         #ifndef CSF
            if(SET.RELATION)                               // Relation Open
            {
               BAKtmp=ACTIVE;
               Relation(name);                             // Relation Open
               ChangeEditStatus(BAKtmp);
            }
         #endif
      }
      else
      {
         Quit();
         return(-1);
      }
   }

   // ------------------  INITNAME ɮ ------------------
   if(INITNAME[0]!='\0')
   {
      BAKact=ACTIVE;
      BAKtmp=ACTIVE->next;
      while(BAKtmp!=NULL)
      {
         if(stricmp(INITNAME,(*BAKtmp).FNAME)==0)
         {
            if((*BAKtmp).CTRL.MODIFY==OFF)
            {
               ChangeFile(BAKtmp);
               Quit();
               ChangeFile(BAKact);
            }
            INITNAME[0]='\0';
            break;
         }
         if(BAKtmp==ACTIVE) break; else  { BAKtmp=BAKtmp->next; sw++; }
      }
   }
   DisplayFname(name);

   return(0);
}

// ---- 2: ɮפwsb,мg  1: sɧ  0: sɥ ----
int Save(char *fname)
{
   struct LINK *tmp;
   char        name[81];
   int         i,fhandle;
   char        RETURN[]      ={ 0x0a,0x00 };
   char        END_OF_FILE[] ={ 0x1a,0x00 };
   char        str[256];
   int         DISKFULL=OFF;

   if(fname[0]=='.' && strcmp(fname,FNAME)==0)
   {
      DisplayMessage("~ : ɮ, Ts",ON);
      return(0);
   }

   if(GetFullFname(name,fname)==-1)
   {
      DisplayMessage("~ : }ɮ׿~",ON);
      return(0);
   }

   if(access(name,0x00)==0)
   {
      if(strcmp(name,FNAME)!=0)
      {
         DisplayMessage("T : ɮפwgsb,O_мg !! (N)",ON);
         LocateXY(34,LINE.MESSAGE);
         if(toupper(Getch())!='Y')
         {
            DisplayMessage(" ",OFF);
            return(2);
         }
         DisplayMessage(" ",OFF);
      }
      unlink(name);
   }

   if(!ChkDiskWrite(name[0]-'A'))
   {
      DisplayMessage("~ : LkgJɮ (ϺШg) ?!",ON);
      return(0);
   }

   if((fhandle=open(name,O_WRONLY | O_CREAT ,0x0180))==-1)       // 0x0180 = S_IWRITE | S_IREAD (sys\stat.h)
   {
      DisplayMessage("~ : }ɮ׿~",ON);
      return(0);
   }
   else
   {
      tmp=head;
      while(tmp!=NULL && !DISKFULL)
      {
         PointerData(tmp);
         for(i=(U_LEN-1);i>=0;i--) { if(U_STR[i]==' ') U_STR[i]='\0'; else i=-1; }
         if(write(fhandle,U_STR,strlen(U_STR))!=strlen(U_STR)) DISKFULL=ON;
         if(write(fhandle,RETURN,1)!=1)                        DISKFULL=ON;
         tmp=tmp->next;
      }
      if(DISKFULL)
      {
         DisplayMessage("~ : ϺЪŶw ?!",ON);
         close(fhandle);
         return(0);
      }
      write(fhandle,END_OF_FILE,1);                             // EOF ^Z=0x1a
      strcpy(old_text,text);
      if(strcmp(name,FNAME)==0)
      {
         CTRL.MODIFY=OFF;
         DisplayFname(FNAME);
      }
   }
   close(fhandle);

   return(1);
}

// ---- 2: ɮפwsb,мg  1: sɧ  0: sɥ ----
int SaveMark(char *fname)
{
   struct LINK   *tmp;
   struct BACKUP *BAKtmp;
   int           i,fhandle;
   char          *ts;
   char          name[81];
   char          str[256];
   char          RETURN[]      ={ 0x0a,0x00 };
   char          END_OF_FILE[] ={ 0x1a,0x00 };
   int           DISKFULL=OFF;

   if(!CTRL.MARK)                   { DisplayMessage("~ : ХаOϰ",ON);  return(0);  }
   if(GetFullFname(name,fname)==-1) { DisplayMessage("~ : }ɮ׿~",ON); return(0); }

   if(access(name,0x00)==0)
   {
      if(strcmp(name,FNAME)!=0)
      {
         DisplayMessage("T : ɮפwgsb,O_мg !! (N)",ON);
         LocateXY(34,LINE.MESSAGE);
         if(toupper(Getch())!='Y')
         {
            DisplayMessage(" ",OFF);
            return(2);
         }
         DisplayMessage(" ",OFF);
      }
      unlink(name);
   }

   if(!ChkDiskWrite(name[0]-'A'))
   {
      DisplayMessage("~ : LkgJɮ (ϺШg) ?!",ON);
      return(0);
   }

   if((fhandle=open(name,O_WRONLY | O_CREAT ,0x0180))==-1)       // 0x0180 = S_IWRITE | S_IREAD (sys\stat.h)
   {
      DisplayMessage("~ : }ɮ׿~",ON);
      return(0);
   }

   // ----------------- ثeu@ɮ, D MARK ɮ -----------------
   BAKtmp=ACTIVE;
   if(CTRL.MARKFILE!=ACTIVE) ChangeEditStatus(CTRL.MARKFILE);

   // ---------------------- V MARKY @ ---------------------
   tmp=head;
   for(i=1;i<POS.MARKY;i++) tmp=tmp->next;
   ChangeEditStatus(BAKtmp);

   for(i=POS.MARKY;i<=POS.MARKY1 && !DISKFULL;i++)      // MARK ϰ@Bz
   {
      PointerData(tmp);
      if(POS.MARKX)                                     // BLOCK MARK
      {
         if(U_LEN>=POS.MARKX)
         {
            U_STR[POS.MARKX1]='\0';
            ts =U_STR+(POS.MARKX-1);
            if(write(fhandle,ts,strlen(ts))!=strlen(ts)) DISKFULL=ON;
         }
      }
      else
      {
         if(write(fhandle,U_STR,U_LEN)!=U_LEN) DISKFULL=ON;
      }
      write(fhandle,RETURN,1);
      tmp=tmp->next;
   }
   write(fhandle,END_OF_FILE,1);                             // EOF ^Z=0x1a
   close(fhandle);

   if(DISKFULL)
   {
      DisplayMessage("~ : ϺЪŶw ?!",ON);
      return(0);
   }
   return(1);

}

int Locate(char *keystr)
{
   struct LINK *tmp;
   char        str[256],*ts;
   int         offset=POS.NOWX;
   int         cnt=-1;
   int         nowx,marx,scrx,len;
   int         posy,posy1;
   int         REDISPLAY=OFF;

   // -------- ثeܪϰ -------
   posy =POS.NOWY + (LINE.SCRY -POS.SCRY) ;
   posy1=POS.NOWY + (LINE.SCRY1-POS.SCRY) ;

   if(!SET.SEARCHCASE) StrUpr(keystr);                  // jpg@P
   tmp=now;
   while(tmp!=NULL)
   {
      cnt++;
      PointerData(tmp);
      if(U_LEN<offset) { tmp=tmp->next; offset=0; continue; }

      strcpy(str,U_STR+offset);                 // qФU@r}l
      if(!SET.SEARCHCASE) StrUpr(str);          // jpg@P
      if((ts=strstr(str,keystr))==NULL)         // 䤣
      {
         tmp=tmp->next;
         offset=0;
         continue;
      }
      else                                      // F
      {
         now=tmp;
         POS.NOWY +=cnt;                        // s NOWY
         POS.NOWX  =(ts-str)+offset+1;

         // ------- pXs NOWX, SCRX, MARX -----
         marx=0;
         len =POS.NOWX;
         if((len-marx)>=80)
         {
            if(len<80)
            {
               marx =0;
               scrx =len;
            }
            else
            {
               marx =0;
               while((len+1)>60) { marx +=20; len -=20; }
               scrx =len;
            }

            POS.SCRX=scrx;
            if(marx!=POS.MARX)                  // POS.MARX @˻ݭs
            {
               POS.MARX =marx;
               REDISPLAY=ON;
            }
         }
         else
         {
            POS.SCRX=POS.NOWX;
            if(POS.MARX!=0)                     // POS.MARX @˻ݭs
            {
               POS.MARX =0;
               REDISPLAY=ON;
            }
         }

         if(POS.NOWY<posy || POS.NOWY>posy1)    // KEYSTR bثeܰϰ
         {
            POS.SCRY =LINE.SCRY1;
            REDISPLAY=ON;
         }
         else
         {
            POS.SCRY +=cnt;
         }

         if(REDISPLAY)
         {
            DISPLAY.REDISPLAY=ON;
            DISPLAY.SCRY     =1;
            DISPLAY.CNT      =(LINE.SCRY1-LINE.SCRY+1);
         }
         return(1);
      }
   }
   return(0);
}

void Dos(char *command)
{
   #ifndef CSF
      unsigned seg;

      ClrScr(1,1,80,25,0x07);
      if(*command=='\0')
      {
         LocateXY(1,2);
         printf("J 'Exit' ^iѡj");
      }

      system(command);

      if(*command!='\0')
      {
         ClrScr(1,23,80,25,0x07);
         LocateXY(1,24); printf("------ N^iѡj------");  getch();
      }
      SLEEP=AUTOSAVE=GetMinute();
      Refresh();
   #else
      if(*command!='\0') { }
   #endif
}

void Line(char *line_str)
{
   int line_no;

   line_no=atoi(line_str);
   CmdLine(line_no);
}

double Calc(char *ss)
{
   long   i=0, t=0, d=0, ptr=0, top=0, cnt=0;
   char   oprt[64][20],oprd[64][20];
   double result,num[64];
   char   CH,act;
   int    oprd_total=0;
   char   *ts,*str;
   char   str1[280];

   strcpy(RESULT,"0.00");

   // --------------------- ƦrH~r ---------------------
   ts=BOXSTR;
   while(*ss!='\0')
   {
      if(*ss>='0' && *ss<='9') *ts++=*ss;
      if(*ss=='(' || *ss==')') *ts++=*ss;
      if(*ss=='+' || *ss=='-') *ts++=*ss;
      if(*ss=='*' || *ss=='/') *ts++=*ss;
      if(*ss=='.')             *ts++=*ss;
      ss++;
   }
   if(ts==BOXSTR) return(0); else *ts='\0';

   strcpy(str1," ");
   strcat(str1,BOXSTR);
   i=strlen(str1)-1;
   if(str1[i]=='+' || str1[i]=='-') strcat(str1,"0");   // B⦡p 12+ |~
   if(str1[i]=='*' || str1[i]=='/') strcat(str1,"1");   // B⦡p 12/ |~
   if(str1[1]=='-')                 str1[0]='0';        // B⦡p -12 |~
   if(str1[1]=='+')                 str1[1]=' ';        // B⦡p +12 |~
   if(str1[1]=='*' || str1[0]=='/') str1[1]=' ';        // B⦡p /12 |~
   strcat(str1,"+0");

   str=str1;
   for(i=0;i<64;i++)   {  oprt[i][0]=oprd[i][0]='\0';   }

   while((CH=*str)!='\0')
   {
      str++;
      switch(CH)
      {
         case  '(' :
               cnt=0;
               t++;
               oprt[t][0]=CH;
               oprt[t][1]='\0';
               break;
         case  ')' :
               cnt=0;
               while(1)
               {
                  d++;
                  strcpy(oprd[d],oprt[t]);
                  t--;
                  if(oprt[t][0]=='(' || t==0) break;
               }
               if(oprt[t][0]=='(') t--;
               break;
         case  '*' :
         case  '/' :
               cnt=0;
               if(t>0 && (oprt[t][0]=='*' || oprt[t][0]=='/'))
               {
                  d++;
                  strcpy(oprd[d],oprt[t]);
               }
               else
               {
                  t++;
               }
               oprt[t][0]=CH;
               oprt[t][1]='\0';
               break;
         case  '+' :
         case  '-' :
               cnt=0;
               if(t>0 && oprt[t][0]!='(')
               {
                  while(1)
                  {
                     d++;
                     strcpy(oprd[d],oprt[t]);
                     t--;
                     if(oprt[t][0]=='(' || t==0) break;
                  }
                  if(oprt[t][0]=='(' || t==0) { t++; oprt[t][0]=CH; oprt[t][1]='\0'; }
               }
               else
               {
                  t++;
                  oprt[t][0]=CH;
                  oprt[t][1]='\0';
               }
               break;
         default :
               if(cnt==0) d++;
               oprd[d][cnt++]=CH;
               oprd[d][cnt]  ='\0';
               break;
      }
   }

   for(i=t;i>=1;i--) strcpy(oprd[++d],oprt[i]);

   oprd_total=d;
   result    =0;
   ptr       =1;
   top       =0;
   while(ptr<=oprd_total)
   {
      switch(oprd[ptr][0])
      {
         case  '+' : result=num[top-1] + num[top];    break;
         case  '-' : result=num[top-1] - num[top];    break;
         case  '*' : result=num[top-1] * num[top];    break;
         case  '/' : if(num[top]==0)                  break;
                     result=num[top-1] / num[top];    break;
         default   : num[++top]=atof(oprd[ptr]);      break;
      }

      act=oprd[ptr][0];
      if(act=='+' || act=='-' || act=='*' || act=='/')  num[--top]=result;
      ptr++;
   }
   sprintf(RESULT,"%.2f",result);
   return(result);
}

int Change(char *old_str, char *new_str, int mode)
{
   struct POS_STRUCT pos;
   struct LINK       *tmp;
   int               FIND=OFF;
   int               len;
   char              str[512];
   char              str1[512];
   int               scrx1,scrx2;

   if(*old_str=='\0') return(1);

   if(mode==2 && !POS.MARKX)                            // LINE MARK
   {
      scrx1=1;         scrx2=255-strlen(old_str)+1;
   }
   else
   {
      scrx1=POS.MARKX; scrx2=POS.MARKX1-strlen(old_str)+1;
   }

   pos.NOWY=POS.NOWY;
   pos.NOWX=POS.NOWX;
   pos.SCRY=POS.SCRY;
   pos.SCRX=POS.SCRX;
   pos.MARX=POS.MARX;
   tmp     =now;

   len=strlen(new_str)-1;
   while(Locate(old_str))
   {
      NowdataToText(now);               //  now->data ƻs text
      if(mode==2)                       // Mark Change
      {
         if(POS.NOWY>POS.MARKY1)                         break;
         if(POS.NOWY<POS.MARKY)                          continue;
         if((POS.NOWX<scrx1     || POS.NOWX>scrx2))      continue;
      }
      pos.NOWY=POS.NOWY;                // OdWm, _h c/^^/^^/*m  m|
      pos.NOWX=POS.NOWX;
      pos.SCRY=POS.SCRY;
      pos.SCRX=POS.SCRX;
      pos.MARX=POS.MARX;

      FIND=ON;
      MidStr(str ,text,1,POS.NOWX-1);
      MidStr(str1,text,POS.NOWX+strlen(old_str),255);
      strcat(str ,new_str);
      strcat(str ,str1);
      str[255]='\0';
      strcpy(text,str);                 //  MallocData  CTRL.MODIFY=ON
      if(!MallocData(now,text)) break;  // ǤJM᪺ now V@, H NEW @ǻ
      now       =NEW;
      tmp       =now;
      POS.NOWX +=len;
   }

   POS.NOWY=pos.NOWY;                // ̫@ found m
   POS.NOWX=pos.NOWX;
   POS.SCRY=pos.SCRY;
   POS.SCRX=pos.SCRX;
   POS.MARX=pos.MARX;
   now     =tmp;
   if(FIND)
   {
      if(CTRL.COMMAND) CommandToggle();
      NowdataToText(now);               //  now->data ƻs text
      CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
      return(1);
   }
   return(0);
}

int Delete(char *old_str, int mode)
{
   struct POS_STRUCT pos;
   struct LINK       *tmp;
   int               FIND=OFF;
   int               scrx1,scrx2;

   if(*old_str=='\0') return(1);

   if(mode==2 && !POS.MARKX)            // LINE MARK
   {
      scrx1=1;         scrx2=255-strlen(old_str)+1;
   }
   else
   {
      scrx1=POS.MARKX; scrx2=POS.MARKX1-strlen(old_str)+1;
   }

   pos.NOWY=POS.NOWY;
   pos.NOWX=POS.NOWX;
   pos.SCRY=POS.SCRY;
   pos.SCRX=POS.SCRX;
   pos.MARX=POS.MARX;

   tmp =now;
   while(Locate(old_str))
   {
      NowdataToText(now);               //  now->data ƻs text
      if(mode==2)                       // Mark Change
      {
         if(POS.NOWY>POS.MARKY1)                         break;
         if(POS.NOWY<POS.MARKY)                          continue;
         if((POS.NOWX<scrx1     || POS.NOWX>scrx2))      continue;
      }
      DeleteLine(POS.NOWY, POS.NOWY);
      tmp     =now;

      pos.NOWY=POS.NOWY;
      pos.SCRY=POS.SCRY;
      pos.NOWX=POS.NOWX=1;
      pos.SCRX=POS.SCRX=1;
      pos.MARX=POS.MARX=0;
      FIND    =ON;
   }

   POS.NOWY=pos.NOWY;                   // ̫@ Locate m
   POS.NOWX=pos.NOWX;
   POS.SCRY=pos.SCRY;
   POS.SCRX=pos.SCRX;
   POS.MARX=pos.MARX;
   now     =tmp;
   if(FIND)
   {
      if(CTRL.COMMAND) CommandToggle();
      NowdataToText(now);               //  now->data ƻs text
      CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
      return(1);
   }
   return(0);
}

void Number(char *ts1, char *ts2)
{
   int           i,j,sw;
   int           scr,cnt;
   int           len,step;
   int           posy,posy1;
   int           markx,markx1;
   long          num,num1,num2;
   char          str[512],str1[30];
   struct LINK   *tmp;
   struct BACKUP *BAKtmp=NULL;

   if(!CTRL.MARK)   { DisplayMessage("~ : ХаOϰ",ON);  return;  }
   markx =POS.MARKX;
   markx1=POS.MARKX1;

   num1=atol(ts1);
   num2=atol(ts2);

   if(POS.MARKX==0)                             //  LINE MARK
   {
      num=num1+(num2*(POS.MARKY1-POS.MARKY));
      sprintf(str1,"%ld",num);
      POS.MARKX =1;
      POS.MARKX1=strlen(str1)+1;
   }

   if(CTRL.MARKFILE!=ACTIVE)
   {
      BAKtmp=ACTIVE;
      ChangeEditStatus(CTRL.MARKFILE);
   }

   MallocData(now,text);                        // ǤJM᪺ now V@, H NEW @ǻ
   now=NEW;
   tmp=head;
   for(i=1;i<POS.MARKY;i++) tmp=tmp->next;      // V POS.MARKY 檺

   step =POS.MARKX1-POS.MARKX+1;
   for(i=POS.MARKY;i<=POS.MARKY1;i++)           // MARK ϰJƭ
   {
      PointerData(tmp);
      strcpy(str,U_STR);

      // ------- LINE MARK ,JƦrNH'J'Ҧ b̫e -------
      if(markx==0)
      {
         ltoa(num1,str1,10);
         sprintf(str,"%80s"," ");
         MidReplace(str,str1,POS.MARKX1-strlen(str1));
         str[POS.MARKX1]='\0';
         PointerData(tmp);
         strcat(str,U_STR);
         str[255]='\0';
      }
      else                                      // BLOCK MARK, ϥΨNҦ
      {
         len=strlen(str);
         if(len<POS.MARKX1)                     //  MARK ϸɪť
         {
            for(j=len;j<POS.MARKX1;j++) str[j]=' ';
            str[POS.MARKX1]='\0';
         }
         ltoa(num1,str1,10);
         str1[step]='\0';
         MidReplace(str,str1,POS.MARKX1-strlen(str1)+1);
      }

      //------  now=tmp , now ]QV NEW ------
      if(tmp==now) { sw=MallocData(tmp,str); now=NEW; } else sw=MallocData(tmp,str);
      if(!sw) break;
      tmp=NEW;
      tmp=tmp->next;
      num1 +=num2;
   }
   NowdataToText(now);

   POS.MARKX =markx;
   POS.MARKX1=markx1;

   if(BAKtmp!=NULL)                             // MARK ɤu@ , ݭs
   {
      ChangeEditStatus(BAKtmp);
      DISPLAY.REDISPLAY=OFF;
      DISPLAY.SCRY     =1;
      DISPLAY.CNT      =0;
   }
   else
   {
      // ----------------- P_ɮ׬O_Qק -------------------
      if(CTRL.MODIFY==OFF)
      {
         CTRL.MODIFY=ON;
         DisplayFname(FNAME);
      }
      // ---- P_ MARK ϰO_bثeܪϰ ---
      CompareRedrawArea(POS.MARKY, POS.MARKY1, &scr, &cnt);
      CompareRedraw(scr,cnt);
   }
}

// ---- Nثesɮܦ SW wɮ ----
void ChangeEditStatus(struct BACKUP *BAKnew)
{
   MallocData(now,text);        // ǤJM᪺ now V@, H NEW @ǻ
   now=NEW;
   NowdataToText(now);

   // ------ ƥثesɪA ------
   (*ACTIVE).POS.MAXY    =POS.MAXY    ;
   (*ACTIVE).POS.NOWY    =POS.NOWY    ;
   (*ACTIVE).POS.NOWX    =POS.NOWX    ;
   (*ACTIVE).POS.SCRY    =POS.SCRY    ;
   (*ACTIVE).POS.SCRX    =POS.SCRX    ;
   (*ACTIVE).POS.MARX    =POS.MARX    ;
   (*ACTIVE).POS.OLDY    =POS.OLDY    ;
   (*ACTIVE).POS.CMD_NOWX=POS.CMD_NOWX;
   (*ACTIVE).POS.CMD_SCRX=POS.CMD_SCRX;
   (*ACTIVE).POS.CMD_MARX=POS.CMD_MARX;
   (*ACTIVE).POS.CURY    =POS.CURY    ;
   (*ACTIVE).POS.CURX    =POS.CURX    ;

   (*ACTIVE).CTRL.MODIFY =CTRL.MODIFY  ;
   (*ACTIVE).CTRL.COMMAND=CTRL.COMMAND ;
   (*ACTIVE).CTRL.EXIT   =CTRL.EXIT    ;

   //strcpy((*ACTIVE).TEXT    ,text);
   //strcpy((*ACTIVE).OLD_TEXT,old_text);
   strcpy((*ACTIVE).CMD_TEXT,cmd_text);
   strcpy((*ACTIVE).FNAME   ,FNAME);

   (*ACTIVE).HEAD=head;
   (*ACTIVE).NOW =now;
   (*ACTIVE).TAIL=tail;


   // ------ ƥAثesɪA ------
   POS.MAXY    =(*BAKnew).POS.MAXY    ;
   POS.NOWY    =(*BAKnew).POS.NOWY    ;
   POS.NOWX    =(*BAKnew).POS.NOWX    ;
   POS.SCRY    =(*BAKnew).POS.SCRY    ;
   POS.SCRX    =(*BAKnew).POS.SCRX    ;
   POS.MARX    =(*BAKnew).POS.MARX    ;
   POS.OLDY    =(*BAKnew).POS.OLDY    ;
   POS.CMD_NOWX=(*BAKnew).POS.CMD_NOWX;
   POS.CMD_SCRX=(*BAKnew).POS.CMD_SCRX;
   POS.CMD_MARX=(*BAKnew).POS.CMD_MARX;
   POS.CURY    =(*BAKnew).POS.CURY    ;
   POS.CURX    =(*BAKnew).POS.CURX    ;

   CTRL.MODIFY =(*BAKnew).CTRL.MODIFY ;
   CTRL.COMMAND=(*BAKnew).CTRL.COMMAND;
   CTRL.EXIT   =(*BAKnew).CTRL.EXIT   ;

   head=(*BAKnew).HEAD;
   now =(*BAKnew).NOW ;
   tail=(*BAKnew).TAIL;

   PointerData(now);
   strcpy(text    ,U_STR);
   strcpy(old_text,U_STR);
   strcpy(cmd_text,(*BAKnew).CMD_TEXT);
   strcpy(FNAME   ,(*BAKnew).FNAME   );

   ACTIVE=BAKnew;
}

void Words()
{
   long          SPACE=-1;
   unsigned char *ts;
   char          str[81];
   struct LINK   *tmp;
   struct WORD_STRUCT
   {
      long line;
      long chn_word;
      long chn_symbol;
      long eng_word;
      long space;
   };
   struct WORD_STRUCT WORD= { 0,0,0,0,0 };

   tmp=head;
   while(tmp!=NULL)
   {
      WORD.line++;
      PointerData(tmp);
      ts=U_STR;
      while(*ts!='\0')
      {
         // ------------------------- `Φr ----------------------------
         if((*ts>=0xa4 && *ts<=0xc5) && ((*(ts+1)>=0x40 && *(ts+1)<=0x7e) ||
                                         (*(ts+1)>=0xa1 && *(ts+1)<=0xfe)))
         {
            if(SPACE!=-1) { WORD.eng_word++; SPACE=-1; }
            WORD.chn_word++;
            ts +=2;
            continue;
         }
         if(*ts==0xc6  && (*(ts+1)>=0x40 && *(ts+1)<=0x7e))
         {
            if(SPACE!=-1) { WORD.eng_word++; SPACE=-1; }
            WORD.chn_word++;
            ts +=2;
            continue;
         }
         // ------------------------ `Φr ----------------------------
         if((*ts>=0xc9 && *ts<=0xf8) && ((*(ts+1)>=0x40 && *(ts+1)<=0x7e) ||
                                         (*(ts+1)>=0xa1 && *(ts+1)<=0xfe)))
         {
            if(SPACE!=-1) { WORD.eng_word++; SPACE=-1; }
            WORD.chn_word++;
            ts +=2;
            continue;
         }
         if((*ts==0xf9)              && ((*(ts+1)>=0x40 && *(ts+1)<=0x7e) ||
                                         (*(ts+1)>=0xa1 && *(ts+1)<=0xd5)))
         {
            if(SPACE!=-1) { WORD.eng_word++; SPACE=-1; }
            WORD.chn_word++;
            ts +=2;
            continue;
         }
         // ------------------------ Ÿr ----------------------------
         if((*ts>=0xa1 && *ts<=0xa2) && ((*(ts+1)>=0x40 && *(ts+1)<=0x7e) ||
                                         (*(ts+1)>=0xa1 && *(ts+1)<=0xfe)))
         {
            if(SPACE!=-1) { WORD.eng_word++; SPACE=-1; }
            WORD.chn_symbol++;
            ts +=2;
            continue;
         }
         if((*ts==0xf9)              && ((*(ts+1)>=0x40 && *(ts+1)<=0x7e) ||
                                         (*(ts+1)>=0xa1 && *(ts+1)<=0xe0)))
         {
            if(SPACE!=-1) { WORD.eng_word++; SPACE=-1; }
            WORD.chn_symbol++;
            ts +=2;
            continue;
         }

         // ------------------------ Ÿr ----------------------------
         if((*ts>='a' && *ts<='z') || (*ts>='A' && *ts<='Z'))
         {
            if(SPACE==-1) SPACE=0;
         }
         else
         {
            if(SPACE!=-1) { WORD.eng_word++; SPACE=-1; }
            if(*ts==' ')  WORD.space++;
         }
         ts++;
      }
      if(SPACE!=-1) { WORD.eng_word++;  SPACE=-1; }
      tmp=tmp->next;
   }
   sprintf(str,":%ld  r:%ld  Ÿ:%ld  ^r:%ld  ť:%ld",
               WORD.line,     WORD.chn_word,  WORD.chn_symbol,
               WORD.eng_word, WORD.space );
   DisplayMessage(str,ON);
}

void ClearBakCommandLine(struct BACKUP *BAKtmp)
{
   (*BAKtmp).CMD_TEXT[0] ='\0';
   (*BAKtmp).POS.CMD_NOWX=1;
   (*BAKtmp).POS.CMD_SCRX=1;
   (*BAKtmp).POS.CMD_MARX=0;
}

// -----------------------------------------------------------------------
// 0 : `}     -1 : DrɩΰO^Ŷ    -2 : WL MAXOPEN
// -----------------------------------------------------------------------
int Insert(char *fname)
{
   #ifndef CSF
      int           len,sw;
      int           fhandle;
      char          str[513];
      char          name[81];
      int           ERROR=OFF;
      struct LINK   *tmp;

      // ---------- Insert ϰ츨bаO, h UnMark() --------
      if(CTRL.MARKFILE==ACTIVE && (POS.NOWY>=POS.MARKY && POS.NOWY<POS.MARKY1)) UnMark();

      tmp=now;
      // ------------------ o㪺ɮצW ----------------
      if(GetFullFname(name,fname)==-1)
      {
         DisplayMessage("~ : }ɮ׿~",ON);
         return(-1);
      }
      // --------------- P_ɮ׬O_r -----------------
      sw=ChkIsText(name);
      if(sw==0)                                    // ɮפr
      {
         DisplayMessage("~ : ɮפr",ON);
         return(-1);
      }

      if(sw!=-1)                                   // s}ɮ
      {
         // --------------------- }lJɮ --------------------
         DisplayMessageNoBeep("T : ɮ״J,еy.... ");

         fhandle=open(name,O_RDONLY | O_TEXT);
         while(Fgets(fhandle,str,0)!=-1)
         {
            CompressSpace(STR,str);
            if((new=AllocMemString(STR))!=NULL)       // Otm\
            {
               DP=DATAPointerData(new);
               strcpy(DP,STR);
            }
            else
            {
               ERROR=ON;
               break;
            }
            new->next=now->next;
            new->prev=now;
            if(now->next!=NULL) { (now->next)->prev=new; } else { tail=new; }
            now->next=new;
            now      =new;
            if(CTRL.MARKFILE==ACTIVE && POS.MARKY>=POS.NOWY) { POS.MARKY++; POS.MARKY1++; }
            POS.MAXY++;
         }
         close(fhandle);

         // ------------------ YJ\ -----------------------
         if(!ERROR)
         {
            now=tmp;
            NowdataToText(now);
            DisplayMessage(" ",OFF);
            CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
         }
         else
         {
            Quit();
            return(-1);
         }
      }
      CTRL.MODIFY=ON;
      DisplayFname(FNAME);
      return(0);
   #else
      if(fname[0]=='\0') { }
      return(-1);
   #endif
}

void Execute()
{
   char CMD[][9]=
   {
        "QUIT"     ,         // 0
        "Q"        ,         // 1
        "SAVE"     ,         // 2
        "FILE"     ,         // 3
        "EDIT"     ,         // 4
        "E"        ,         // 5
        "PRINT"    ,         // 6
        "LINE"     ,         // 7
        "DOS"      ,         // 8
        "CD"       ,         // 9
        "DIR"      ,         // 10
        "ERASE"    ,         // 11
        "RENAME"   ,         // 12
        "RUN"      ,         // 13
        "CALC"     ,         // 14
        "?"        ,         // 15
        "FILL"     ,         // 16
        "NUMBER"   ,         // 17
        "SET"      ,         // 18
        "SAVEMARK" ,         // 19
        "SORT"     ,         // 20
        "WORDS"    ,         // 21
        "DEL"      ,         // 22
        "NAME"     ,         // 23
        "MACRO"    ,         // 24
        "GRID"     ,         // 25
        "HELP"     ,         // 26
        "SUM"      ,         // 27
        "INSERT"   ,         // 28
        "ED"       ,         // 29
        "\0"
   };
   char CMD1[][3]=
   {
        "C"      ,           // 0
        "L"      ,           // 1
        "S"      ,           // 2
        "D"      ,           // 3
        "\0"
   };

   struct BACKUP *BAKtmp;
   char          cmd[10][256];
   char          delimiter[5],*ts;
   char          str[256],str1[256];
   int           sw =0, ch;
   int           cnt=0;
   int           CLEAR=OFF;
   double        calc;

   for(sw=0;sw<9;sw++) cmd[sw][0]='\0';
   // ---------- ǤJM᪺ now V@, H NEW @ǻ  ----------
   MallocData(now,text);
   now=NEW;
   NowdataToText(now);

   strcpy(str,cmd_text);
   if(!EraseSpace(str)) return;

   // -------------------------- O ---------------------------
   CommandSave(str);

   // ----------------------- P_O_O ------------------------
   if(str[0]=='[')
   {
      #ifndef CSF
         CTRL.MACRO=ON;
         DisplayMessage(" ",OFF);
         BAKtmp=ACTIVE;
         if(MacroStr(str)==-1)
         {
            DisplayMessage("~ : yk~",ON);
         }
         else
         {
            if(BAKtmp==ACTIVE) ClearCommandLine(); else ClearBakCommandLine(BAKtmp);
         }
         CTRL.MACRO=OFF;
         if(!CTRL.MESSAGE) DisplayMessage(" ",OFF);
         return;
      #else
         ClearCommandLine();
         return;
      #endif
   }

   if(str[0]=='/')                { strcpy(str1,"L");     strcat(str1,str); strcpy(str,str1); }
   if(str[0]>='0' && str[0]<='9') { strcpy(str1,"LINE "); strcat(str1,str); strcpy(str,str1); }

   ch=toupper(str[0]);
   if(str[1]=='/' && (ch=='C' || ch=='L' || ch=='S' || ch=='D'))
   {
      strcpy(delimiter,"/");                            // , ŧR
      cnt=StrTok(str,cmd);                              // wqb TOOLS.C
      sw=0;
      while(CMD1[sw][0]!='\0')
      {
         if(stricmp(CMD1[sw],cmd[0])==0) break; else sw++;
      }
   }
   else
   {
      strcpy(delimiter," ");
      ts=strtok(str,delimiter);
      while(ts!=NULL && cnt<10)
      {
         strcpy(cmd[cnt],ts);
         if(cnt==0)
         {
            if(stricmp(cmd[cnt],"CALC")==0  || stricmp(cmd[cnt],"?"   )==0 ||
               stricmp(cmd[cnt],"RUN") ==0  || stricmp(cmd[cnt],"FILL")==0)
            {
               strcpy(delimiter,"\0x0a");
            }
         }
         cnt++;
         ts=strtok(NULL,delimiter);
      }

      sw=0;
      while(CMD[sw][0]!='\0')
      {
        if(stricmp(CMD[sw],cmd[0])==0) break; else sw++;
      }
   }

   if(delimiter[0]=='/')
   {
      switch(sw)
      {
         case  0 :  // C
               if(cnt==4)
               {
                  sw=1;
                  POS.OLDY=POS.SCRY;                    // Odʧ@ePOS.SCRY
                  if(stricmp(cmd[3],"*")==0)
                  {
                     sw=Change(cmd[1],cmd[2],1);        // 
                  }
                  else
                  {
                     if(stricmp(cmd[3],"*m")==0)
                     {
                        if(CTRL.MARK!=ON)         { DisplayMessage("~ : ХаOϰ",ON); break; }
                        if(CTRL.MARKFILE!=ACTIVE) { DisplayMessage("~ : аOϰ줣bثeu@ɮ",ON);  break; }
                        sw=Change(cmd[1],cmd[2],2);
                     }
                     else
                     {
                        DisplayMessage("~:O~   yk:C/[¦r]/[sr]/*[m]",ON);
                     }
                  }
                  if(!sw) DisplayMessage("T : 䤣r",ON);
                  break;
               }
               DisplayMessage("~:O~   yk:C/[¦r]/[sr]/[*][*m]",ON);
               if(!CTRL.COMMAND) CommandToggle();
               break;
         case  1 :  // L
               if(cnt==2)
               {
                  POS.OLDY=POS.SCRY;               // Odʧ@ePOS.SCRY
                  if(Locate(cmd[1]))
                  {
                     if(CTRL.COMMAND) CommandToggle();
                     NowdataToText(now);
                     if(FNAME[0]!='.') DisplayMessageNoBeep(" Ctrl-Enter idߤU@Ӧr");
                  }
                  else
                  {
                     DisplayMessage("T : 䤣r",ON);
                  }
                  break;
               }
               DisplayMessage("~:O~   yk:L/[r]/",ON);
               if(!CTRL.COMMAND) CommandToggle();
               break;
         case  2 :  // S
               #ifndef CSF
                  if(cnt==3)
                  {
                     CLEAR =ON;
                     if(strlen(cmd[1])==0  ) break;
                     if(!EraseSpace(cmd[2])) break;
                     BAKtmp=ACTIVE;
                     sw=Search(cmd[2],cmd[1]);
                     ChangeFile(BAKtmp);
                     if(sw>0)
                     {
                        sprintf(str,"T :  %d ɮ, äw} !!",sw);
                        DisplayMessage(str,ON);
                     }
                     else
                     {
                        DisplayMessage(" ",OFF);
                     }
                     break;
                  }
                  DisplayMessage("~:O~   yk:S/r/ɮ/",ON);
                  if(!CTRL.COMMAND) CommandToggle();
               #else
                  CLEAR=ON;
               #endif
               break;
         case  3 :  // D
               if(cnt==3)
               {
                  sw=1;
                  POS.OLDY=POS.SCRY;                    // Odʧ@ePOS.SCRY
                  if(stricmp(cmd[2],"*")==0)
                  {
                     sw=Delete(cmd[1],1);               // 
                  }
                  else
                  {
                     if(stricmp(cmd[2],"*m")==0)
                     {
                        if(CTRL.MARK!=ON)         { DisplayMessage("~ : ХаOϰ",ON); break; }
                        if(CTRL.MARKFILE!=ACTIVE) { DisplayMessage("~ : аOϰ줣bثeu@ɮ",ON);  break; }
                        sw=Delete(cmd[1],2);
                     }
                     else
                     {
                        DisplayMessage("~:O~   yk:D/[r]/[*][*m]",ON);
                     }
                  }
                  if(!sw) DisplayMessage("T : 䤣r",ON);
                  break;
               }
               DisplayMessage("~:O~   yk:D/[r]/[*][*m]",ON);
               if(!CTRL.COMMAND) CommandToggle();
               break;
         default :  // OTHERS
               DisplayMessage("~ : TO",ON);
               if(!CTRL.COMMAND) CommandToggle();
               break;
      }
   }
   else
   {
      switch(sw)
      {
         case  0 :  // QUIT
         case  1 :  // Q
               EraseSpace(cmd[1]);
               if(cnt==1)                             { Quit();    ChangeMessage(); break; }
               if(cnt==2 && stricmp(cmd[1],"ALL")==0) { QuitAll(); ChangeMessage(); break; }
               DisplayMessage("~:O~   yk:QUIT [ALL]",ON);
               if(!CTRL.COMMAND) CommandToggle();
               break;
         case  2 :  // SAVE
               if(cnt==1) { if(Save(FNAME))  { CLEAR=ON; }   break; }
               if(cnt==2) { if(Save(cmd[1])) { CLEAR=ON; }   break; }
               DisplayMessage("~:O~   yk:SAVE [sɦW]",ON);
               if(!CTRL.COMMAND) CommandToggle();
               break;
         case  3 :  // FILE
               if(cnt==1) { if(Save(FNAME))  {                  Quit(); } break; }
               if(cnt==2) { if(Save(cmd[1])) { CTRL.MODIFY=OFF; Quit(); } break; }
               DisplayMessage("~:O~   yk:FILE [sɦW]",ON);
               if(!CTRL.COMMAND) CommandToggle();
               break;
         case  4 :  // EDIT
         case  5 :  // E
         case 29 :  // ED
               #ifndef CSF
                  if(cnt==1)
                  {
                     DisplayMessage("~:O~   yk:EDIT [ɦW]",ON);
                     if(!CTRL.COMMAND) CommandToggle();
                     break;
                  }
                  for(sw=1; sw<cnt; sw++)
                  {
                     BAKtmp=ACTIVE;
                     if(Edit(cmd[sw])==-2) break;             // Edit action success
                     ClearBakCommandLine(BAKtmp);
                     ChangeMessage();
                     CLEAR=ON;
                  }
               #else
                  CLEAR=ON;
               #endif
               break;
         case  6 :  // PRINT
               #ifndef CSF
                  EraseSpace(cmd[1]);
                  if(cnt==1)
                  {
                     if(!SET.SHARE) Print(); else PrintShare();
                     CLEAR=ON;
                     break;
                  }
                  if(cnt==2 && stricmp(cmd[1],"MARK")==0)
                  {
                     if(CTRL.MARK)
                     {
                        if(!SET.SHARE) PrintMark(); else PrintMarkShare();
                        CLEAR=ON;
                     }
                     else
                        DisplayMessage("~ : ХаOϰ",ON);
                     break;
                  }
                  if(cnt==2 && stricmp(cmd[1],"STOP")==0)
                  {
                     PrintShareStop();
                     CLEAR=ON;
                     break;
                  }
                  DisplayMessage("~:O~   yk:PRINT [MARK][STOP]",ON);
                  if(!CTRL.COMMAND) CommandToggle();
               #else
                  CLEAR=ON;
               #endif
               break;
         case  7 :  // LINE
               if(cnt==2) { EraseSpace(cmd[1]); Line(cmd[1]); CLEAR=ON; break; }
               DisplayMessage("~:O~   yk:LINE []",ON);
               if(!CTRL.COMMAND) CommandToggle();
               break;
         case  8 :  // DOS
               #ifndef CSF
                  if(cnt==1) { Dos(""); CLEAR=ON; break; }
                  DisplayMessage("~:O~   yk:DOS ",ON);
                  if(!CTRL.COMMAND) CommandToggle();
               #else
                  CLEAR=ON;
               #endif
               break;
         case  9 :  // CD
               #ifndef CSF
                  EraseSpace(cmd[1]);
                  if(cnt==2)
                  {
                     if(chdir(cmd[1])!=-1) { CLEAR=ON; break; }
                     DisplayMessage("~ : ҫwؿsb",ON);
                     if(!CTRL.COMMAND) CommandToggle();
                     break;
                  }
                  DisplayMessage("~:O~   yk:CD [|W]",ON);
                  if(!CTRL.COMMAND) CommandToggle();
               #else
                  CLEAR=ON;
               #endif
               break;
         case  10:  // DIR
               #ifndef CSF
                  if(cnt<=2)
                  {
                     BAKtmp=ACTIVE;
                     if(cnt==1) sw=Dir("."); else { EraseSpace(cmd[1]); sw=Dir(cmd[1]); }
                     if(sw==-1) DisplayMessage("T:So{ɮ",ON);
                     if(sw==-2) DisplayMessage("T:ϺоƧ",ON);
                     if(sw== 1) ClearBakCommandLine(BAKtmp);
                     ChangeMessage();
                     break;
                  }
                  DisplayMessage("~:O~   yk:DIR",ON);
                  if(!CTRL.COMMAND) CommandToggle();
               #else
                  CLEAR=ON;
               #endif
               break;
         case  22:  // DEL
         case  11:  // ERASE
               #ifndef CSF
                  if(cnt==2)
                  {
                     EraseSpace(cmd[1]);
                     if(unlink(cmd[1])!=-1) { CLEAR=ON; break; }
                     if(errno==ENOENT)  DisplayMessage("T : wRɮפsb",ON);
                     if(errno==EACCES)  DisplayMessage("T : wɬ@ؿΰŪ",ON);
                     break;
                  }
                  if(sw==22)
                     DisplayMessage("~:O~   yk:DEL [ɦW]"  ,ON);
                  else
                     DisplayMessage("~:O~   yk:ERASE [ɦW]",ON);
               #else
                  CLEAR=ON;
               #endif
               break;
         case  12:  // RENAME
               #ifndef CSF
                  if(cnt==3)
                  {
                     EraseSpace(cmd[1]);
                     EraseSpace(cmd[2]);
                     if(rename(cmd[1],cmd[2])!=-1) { CLEAR=ON; break; }
                     if(errno==ENOENT)  DisplayMessage("T : Wɮפsb",ON);
                     if(errno==EACCES)  DisplayMessage("T : sW٬@ؿΤwsbɮ",ON);
                     if(errno==ENOTSAM) DisplayMessage("T : \Nɮײt@]",ON);
                     break;
                  }
                  DisplayMessage("~:O~   yk:RENAME [ɦW] [sɦW]",ON);
                  if(!CTRL.COMMAND) CommandToggle();
               #else
                  CLEAR=ON;
               #endif
               break;
         case  13:  // RUN
               #ifndef CSF
                  if(cnt==2)
                  {
                     EraseSpace(cmd[1]);
                     Dos(cmd[1]);
                     CLEAR=ON;
                     break;
                  }
                  DisplayMessage("~:O~   yk:RUN [檺DOSO]",ON);
                  if(!CTRL.COMMAND) CommandToggle();
               #else
                  CLEAR=ON;
               #endif
               break;
         case  14:  // ?
         case  15:  // CALC
               if(cnt==1)
               {
                  #ifndef CSF
                     clrscr();
                     system("ecalc.exe");
                     Refresh();
                  #else
                     CLEAR=ON;
                  #endif
                  break;
               }
               if(cnt==2)
               {
                  EraseSpace(cmd[1]);
                  POS.OLDY=POS.SCRY;               // Odʧ@ePOS.SCRY
                  calc=Calc(cmd[1]);
                  sprintf(str,"T : pȬ (%.2f)  hex=(%.4x %.4x)  Ctrl-2 iNpȱaX!!",calc, (int)((long)calc>>16),(int)((long)calc & 0xffff));
                  DisplayMessage(str,ON);
                  CLEAR=ON;
                  break;
               }
               DisplayMessage("~:O~   yk:CALC [B⦡]",ON);
               if(!CTRL.COMMAND) CommandToggle();
               break;
         case  16:  // FILL
               if(CTRL.MARKFILE==NULL) { DisplayMessage("~:ХаOϰ",ON); break; }
               if(cnt==2) { MarkFill(cmd[1]); CLEAR=ON; break; }
               if(cnt==1) { MarkFill(NULL);   CLEAR=ON; break; }
               DisplayMessage("~:O~   yk:FILL [Jr]",ON);
               if(!CTRL.COMMAND) CommandToggle();
               break;
         case  17:  // NUMBER
               if(CTRL.MARKFILE==NULL) { DisplayMessage("~:ХаOϰ",ON); break; }
               if(cnt==3)
               {
                  EraseSpace(cmd[1]);
                  EraseSpace(cmd[2]);
                  POS.OLDY=POS.SCRY;               // Odʧ@ePOS.SCRY
                  Number(cmd[1],cmd[2]);
                  CLEAR=ON;
                  break;
               }
               DisplayMessage("~:O~   yk:NUMBER [_l] [j]",ON);
               if(!CTRL.COMMAND) CommandToggle();
               break;
         case  18:   // SET
               #ifndef CSF
                  if(cnt==3)
                  {
                     sw=0;
                     EraseSpace(cmd[1]);
                     EraseSpace(cmd[2]);
                     if(stricmp(cmd[1],"ExactSearch")==0) sw=1;
                     if(stricmp(cmd[1],"TIMER")      ==0) sw=2;
                     if(stricmp(cmd[1],"BEEP")       ==0) sw=3;
                     if(stricmp(cmd[1],"RELATION")   ==0) sw=4;
                     if(stricmp(cmd[1],"AUTOPAGE")   ==0) sw=5;
                     if(stricmp(cmd[1],"SHARE")      ==0) sw=7;
                     if(stricmp(cmd[1],"Dir")        ==0)
                     {
                        if(stricmp(cmd[2],"NAME")==0) { CLEAR=ON; SET.DIR=1; break; }
                        if(stricmp(cmd[2],"DATE")==0) { CLEAR=ON; SET.DIR=2; break; }
                        if(stricmp(cmd[2],"SIZE")==0) { CLEAR=ON; SET.DIR=3; break; }
                        DisplayMessage("~:O~   yk:SET [Dir] [NAME/DATE/SIZE]",ON);
                        if(!CTRL.COMMAND) CommandToggle();
                        break;
                     }
                     if(stricmp(cmd[1],"AutoSave")==0)
                     {
                        CLEAR=ON; SET.AUTOSAVE=atoi(cmd[2]); break;
                     }
                     if(stricmp(cmd[1],"Sleep")==0)
                     {
                        CLEAR=ON; SET.SLEEP=atoi(cmd[2]);
                        if(SET.SLEEP<0)  SET.SLEEP=0;
                        if(SET.SLEEP==1) SET.SLEEP=2;
                        break;
                     }
                     if(stricmp(cmd[1],"COLOR")==0)
                     {
                        CLEAR=ON; SET.EDITCOLOR=atoi(cmd[2]);
                        if(SET.EDITCOLOR<1 || SET.EDITCOLOR>7) SET.EDITCOLOR=7;
                        if(MONITOR==MONO) SET.EDITCOLOR=0x07;
                        CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
                        break;
                     }
                     if(sw)
                     {
                        if(stricmp(cmd[2],"ON")==0)
                        {
                           switch(sw)
                           {
                             case 1: SET.SEARCHCASE=ON;  break;
                             case 2: SET.TIMER     =ON;  break;
                             case 3: SET.BEEP      =ON;  break;
                             case 4: SET.RELATION  =ON;  break;
                             case 5: SET.AUTOPAGE  =ON;  break;
                             case 7: SET.SHARE     =ON;  break;
                           }
                           CLEAR=ON;  break;
                        }
                        if(stricmp(cmd[2],"OFF")==0)
                        {
                           switch(sw)
                           {
                             case 1: SET.SEARCHCASE=OFF; break;
                             case 2: SET.TIMER     =OFF;
                                     ColorPuts1(42,LINE.STATUS,"           ",0x0F);
                                     break;
                             case 3: SET.BEEP      =OFF; break;
                             case 4: SET.RELATION  =OFF; break;
                             case 5: SET.AUTOPAGE  =OFF; break;
                             case 7: SET.SHARE     =OFF; break;
                           }
                           CLEAR=ON;  break;
                        }
                     }
                  }
                  DisplayMessage("~:O~   yk:SET [ExactSearch, Timer, Beep, Relation, AutoPage] [ON/OFF]",ON);
                  if(!CTRL.COMMAND) CommandToggle();
               #else
                  CLEAR=ON;
               #endif
               break;
         case  19:   // SAVEMARK
               #ifndef CSF
                  if(cnt==2)
                  {
                     if(CTRL.MARKFILE==NULL) { DisplayMessage("~:ХаOϰ",ON); break; }
                     EraseSpace(cmd[1]);
                     if(SaveMark(cmd[1])) CLEAR=ON;
                     break;
                  }
                  DisplayMessage("~:O~   yk:SAVEMARK [sɦW]",ON);
               #else
                  CLEAR=ON;
               #endif
               break;
         case  20:   // SORT
               if(cnt==2)
               {
                  if(CTRL.MARKFILE==NULL) { DisplayMessage("~:ХаOϰ",ON); break; }
                  sw=0;
                  EraseSpace(cmd[1]);
                  if(strcmp(cmd[1],"+" )==0) sw=1;   // W, jpg@
                  if(strcmp(cmd[1],"-" )==0) sw=2;   // , jpg@
                  if(strcmp(cmd[1],"+=")==0) sw=3;   // W, jpg@
                  if(strcmp(cmd[1],"-=")==0) sw=4;   // , jpg@
                  if(sw)
                  {
                     if(MarkSort(sw)) CLEAR=ON;
                     break;
                  }
               }
               DisplayMessage("~:O~   yk:SORT [+][-][+=][-=]",ON);
               break;
         case  21:   // WORDS
               if(cnt==1)
               {
                  Words(); CLEAR=ON; break;
               }
               DisplayMessage("~:O~   yk:Word ",ON);
               break;
         case  23:   // NAME
               #ifndef CSF
                  if(cnt==2)
                  {
                     if(GetFullFname(str1,cmd[1])==-1)
                     {
                        DisplayMessage("~ : TɮצW",ON);
                     }
                     else
                     {
                        CTRL.MODIFY=ON;
                        CLEAR      =ON;
                        strcpy(FNAME,str1);
                        DisplayFname(FNAME);
                     }
                     break;
                  }
                  DisplayMessage("~:O~   yk:NAME [ɮצW]",ON);
               #else
                  CLEAR=ON;
               #endif
               break;
         case  24:   // MACRO
               #ifndef CSF
                  if(FREE)
                  {
                     DisplayMessage("T : KO MACRO Oϥ",ON);
                     break;
                  }
                  CTRL.MACRO=ON;
                  DisplayMessage(" ",OFF);
                  if(cnt==2)
                  {
                     if((sw=Macro(cmd[1]))>0)
                     {
                        sprintf(str,"~:ɲ %d 榳~",sw);  DisplayMessage(str,ON);
                     }
                     else
                     {
                        DisplayMessage("槹!!",ON);        CLEAR=ON;
                     }
                     CTRL.MACRO=OFF;
                     break;
                  }
                  DisplayMessage("~:O~   yk:MACRO [ɮ]",ON);
                  CTRL.MACRO=OFF;
               #else
                  CLEAR=ON;
               #endif
               break;
         case  25:   // GRID
               if(cnt==5)
               {
                  if(BoxGrid(cmd[1],cmd[2],cmd[3],cmd[4])) CLEAR=ON;
                  break;
               }
               DisplayMessage("~:O~   yk:GRID [] [] [C氪()] [Ce(r)]",ON);
               break;
         case  26:
               MenuProcess();
               //BAKtmp=ACTIVE;
               //Edit(HELP);
               //ClearBakCommandLine(BAKtmp);
               break;
         case  27:   // SUM
               if(CTRL.MARKFILE==NULL) { DisplayMessage("~:ХаOϰ",ON); break; }
               if(cnt==1)
               {
                  sprintf(str,"T : pȬ (%.2f)   Ctrl-2 iNpȱaX!!",MarkSum());
                  DisplayMessage(str,ON);
                  CLEAR=ON;
                  break;
               }
               break;
         case  28:   // INSERT
               #ifndef CSF
                  if(cnt!=2)
                  {
                     DisplayMessage("~:O~   yk:Insert [ɦW]",ON);
                     if(!CTRL.COMMAND) CommandToggle();
                     break;
                  }
                  Insert(cmd[1]);
                  CLEAR=ON;
               #else
                  CLEAR=ON;
               #endif
               break;
         default :   // OTHERS
               #ifndef CSF
                  //  ------------- wϺо A: B: ..... ---------------
                  if(cnt==1 && strlen(cmd[0])==2 && cmd[0][1]==':')
                  {
                     if(!SetDisk(cmd[0])) DisplayMessage("~ : ϺоƧ !!",ON);
                     CLEAR=ON;
                     break;
                  }
               #endif
               DisplayMessage("~ : TO",ON);
               if(!CTRL.COMMAND) CommandToggle();
               break;
      }
   }

   if(CLEAR) ClearCommandLine();                // ROT, 槹M
}
