#include <stdio.h>
#include <dos.h>
#include "ems.h"

/* ********************************************************************* */
/*                                                                       */
/* NOTE : UC PROCEDURES tdEMS {, ]A                       */
/*                                                                       */
/*        EMSinstall()       EMS driver O_wgҰ                 */
/*        EMSbackup()       ƥثe EMS A                          */
/*        EMSrestore()      ^sҳƥ EMS A                        */
/*        EMSframe()        o EMS ҨϥΪؤq}                */
/*        EMSavailable()    o EMS iϥέ ( 1 page =16 k )         */
/*        EMStotalamount()  o EMS |iϥΪ̤j                  */
/*        EMSallocblock()   nDtm EMS jp, H              */
/*        EMSfreeblock()    Ұtm EMS Ŷ                        */
/*        EMSversion()      Ǧ^ EMS ޲z{                      */
/*        EMSmapping()      Nڭ޿譶                         */
/*        EMSusableHandle() |iΪ handle (EMS i 64  handle )   */
/*                                                                       */
/* ********************************************************************* */

int EMSinstall(void)
{
   char    *EmmName="EMMXXXX0";
   char    far     *EmmPtr;
   union   REGS    r;
   struct  SREGS   s;

   r.h.ah = 0x35;
   r.h.al = 0x67;
   int86x(0x21,&r,&r,&s);

   EmmPtr = MK_FP(s.es,0x0a);
   while(*EmmName)
   {
      if(*EmmName++ != *EmmPtr++)
      return(0);
   }
   return(1);
}
/*-----------------------------------------*/
unsigned EMSbackup(unsigned handle)
{
   union REGS      r;

   r.h.ah = 0x47;
   r.x.dx = handle;
   int86(0x67,&r,&r);
   return(r.x.bx);
}
/*-----------------------------------------*/
unsigned EMSrestore(unsigned handle)
{
   union REGS      r;

   r.h.ah = 0x48;
   r.x.dx = handle;
   int86(0x67,&r,&r);
   return(r.x.bx);
}
/*-----------------------------------------*/
unsigned EMSframe(void)
{
   union REGS      r;

   r.h.ah = 0x41;
   int86(0x67,&r,&r);
   return(r.x.bx);
}
/*-----------------------------------------*/
unsigned EMSavailable(void)
{
   union REGS  r;

   r.h.ah = 0x42;
   int86(0x67,&r,&r);
   return(r.x.bx);
}
/*------------------------------------------*/
unsigned EMStotalamount(void)
{
   union REGS      r;

   r.h.ah = 0x42;
   int86(0x67,&r,&r);
   return(r.x.dx);
}
/*-------------------------------------------*/
void EMSallocblock(unsigned blocksize,unsigned *handle)
{
   union REGS      r;

   r.x.bx = blocksize;
   r.h.ah = 0x43;
   int86(0x67,&r,&r);
   *handle = r.x.dx;
}
/*-------------------------------------------*/
void EMSfreeblock(unsigned handle)
{
   union REGS      r;

   r.h.ah = 0x45;
   r.x.dx = handle;
   int86(0x67,&r,&r);
}
/*-------------------------------------------*/
int EMSversion(void)
{
   union REGS      r;

   r.h.ah = 0x46;
   int86(0x67,&r,&r);
   return(r.x.ax);
}
/*--------------------------------------------*/
void EMSmapping(unsigned handle,unsigned logpage,char phypage)
{
   union REGS      r;
   static unsigned last_handle;

   if(handle==last_handle) return;
   last_handle=handle;
   r.h.ah     =0x44;
   r.x.dx     =handle;
   r.x.bx     =logpage;
   r.h.al     =phypage;
   int86(0x67,&r,&r);

   //if(r.h.ah != 0)  exit(1);
}

/* ------ EMS have available handle ------- */
int EMSuseableHandle()
{
   union REGS      r;
   unsigned        handle;

   r.x.bx = 1;                          // BLOCK SIZE 1=16K
   r.h.ah = 0x43;                       // ALLOCATE
   int86(0x67,&r,&r);
   handle = r.x.dx;
   if(r.h.ah>0x80)                      // Allocate error
   {
      return(0);
   }
   else                                 // Allocate success
   {
      EMSfreeblock(handle);
      return(1);
   }
}

//  void main()
//  {
//     unsigned handle,handle1;
//     int      i;
//
//     if(EMSinstall() != 1) {puts("1");return;}    // EMS not install
//     if(EMSavailable()< 1) {puts("2");return;}    // not enough EMS
//     EMSP=MK_FP(EMSframe(),0);                    // V EMS 
//     EMSmapping(handle,0,0);                      // MiέƪĤ@
//     for(i=0;i<100;i++)
//     {
//        EMSallocblock(1,&handle);                    // allocate page = EMS
//        printf("handle=%d ",handle);
//     }
//  }

