#include <stdio.h>
#include <string.h>
#include <dir.h>
#include <io.h>
#include <fcntl.h>
#include "tools.h"
#include "we.h"
#define ON       1
#define OFF      0

extern struct SET_STRUCT        SET;
extern struct CTRL_STRUCT       CTRL;
extern char                     RELATION[80];

void  Relation(char *fname);
int   RelationOpen(char *fname);

void Relation(char *fname)
{
   #ifndef CSF
      char driver[MAXDRIVE];
      char directory[MAXDIR];
      char filename[MAXFILE];
      char extension[MAXEXT];
      char cmd[6][80];
      char str[256],data[513];
      char *ts,*ts1;
      int  i,j,cnt,wcnt=0;
      int  fhandle;
      int  EXIT=OFF;
      int  relation;

      if(SET.RELATION==OFF) return;
      fnsplit(fname,driver,directory,filename,extension);

      // ------------------------ ɮŪJ -------------------------
      fhandle=open(RELATION,O_RDWR | O_TEXT);
      if(fhandle==-1) return;

      relation    =SET.RELATION;
      SET.RELATION=OFF;
      while(!EXIT)
      {
         // ----------------------- ŪJ@ -----------------------
         ts   =str;
         *ts  ='\0';
         while(1)
         {
            if(wcnt==0)
            {
               if((wcnt=read(fhandle,data,512))==0) { EXIT=ON; break; }
               ts1=data;
            }
            if(*ts1==0x0a || *ts1==0x0d) { wcnt--; ts1++; break; }
            if(*ts1==0x09) { for(i=0;i<TAB_SPACE;i++) *ts++=' '; } else { *ts++=*ts1; }
            ts1++;
            wcnt--;
         }
         *ts='\0';

         // ----------------- '#' H ---------------------
         for(i=0; i<strlen(str); i++)  { if(str[i]=='#') break;  }
         str[i]='\0';
         if(!EraseSpace(str)) continue;

         cnt=0;
         ts=strtok(str," ");
         while(ts!=NULL && cnt<5)
         {
            strcpy(cmd[cnt++],ts);
            ts=strtok(NULL," ");
         }

         if(cmd[0][0]=='.')                        // ɦW
         {
            if(stricmp(extension,cmd[0])==0)
            {
               for(i=1;i<cnt;i++)
               {
                  if(cmd[i][0]=='.')
                     sprintf(str,"%s%s%s%s",driver,directory,filename,cmd[i]);
                  else
                     strcpy(str,cmd[i]);
                  if(RelationOpen(str)==-2) EXIT=ON;
               }
            }
         }
         else
         {
            if(extension[0]=='\0')  strcpy(str,filename); else sprintf(str,"%s%s",filename,extension);
            if(stricmp(str,cmd[0])==0)
            {
               for(i=1; i<cnt && !EXIT; i++) if(RelationOpen(cmd[i])==-2) EXIT=ON;
            }
         }
      }
      close(fhandle);
      SET.RELATION=relation;
   #else
      if(fname[0]=='\0') { }
   #endif
}

// -----------------------------------------------------------------
//  0: Relation Ok
// -1: Too many file opened
// -----------------------------------------------------------------
int RelationOpen(char *fname)
{
   #ifndef CSF
      char str[256];
      int  sw;

      GetFullFname(str,fname);
      if(access(str,0x00)!=0) return(0);
      CTRL.INIT=OFF;
      sw=Edit(fname);
      CTRL.INIT=ON;
      if(sw==-2) return(-1); else return(0);
   #else
      if(fname[0]=='\0') { }
      return(-2);
   #endif
}
